import { Event } from "select-when";
export interface PicoEventPayload {
    attrs: {
        [name: string]: any;
    };
}
export interface PicoEvent extends Event<PicoEventPayload> {
    eci: string;
    domain: string;
    name: string;
    data: PicoEventPayload;
    time: number;
}
/**
 * Given an event json (i.e. from the web, or somewhere untrusted)
 *   + assert the required pieces are there
 *   + normalize the shape/naming conventions
 *   + make a full copy (clone) as to not mutate the original
 */
export declare function cleanEvent(eventOrig: any, time?: number): PicoEvent;
