import { PicoEvent } from "./PicoEvent";
import { PicoQuery } from "./PicoQuery";
import { PicoFrameworkEvent } from "./PicoFrameworkEvent";
export interface PicoTxn_base {
    id: string;
}
export interface PicoTxn_event extends PicoTxn_base {
    kind: "event";
    event: PicoEvent;
}
export interface PicoTxn_query extends PicoTxn_base {
    kind: "query";
    query: PicoQuery;
}
export type PicoTxn = PicoTxn_event | PicoTxn_query;
export declare class PicoQueue {
    private picoId;
    private worker;
    private emit;
    private txnLog;
    private txnWaiters;
    private isWorking;
    private currentTxn;
    constructor(picoId: string, worker: (txn: PicoTxn) => Promise<any>, emit: (txn: PicoFrameworkEvent) => void);
    push(txn: PicoTxn): void;
    waitFor(id: string): Promise<any>;
    getCurrentTxn(): PicoTxn | undefined;
    private doWork;
}
