"use strict";
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dbRange = void 0;
async function dbRange(db, opts, onData) {
    var _a, e_1, _b, _c;
    const promises = [];
    let streamOpts = {};
    if (opts && Array.isArray(opts.prefix)) {
        streamOpts.gte = opts.prefix;
        streamOpts.lte = opts.prefix.concat([undefined]); // bytewise sorts with null at the bottom and undefined at the top
    }
    const iter = db.iterator(streamOpts);
    try {
        for (var _d = true, iter_1 = __asyncValues(iter), iter_1_1; iter_1_1 = await iter_1.next(), _a = iter_1_1.done, !_a; _d = true) {
            _c = iter_1_1.value;
            _d = false;
            const [key, value] = _c;
            promises.push(Promise.resolve(onData({ key, value })));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (!_d && !_a && (_b = iter_1.return)) await _b.call(iter_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return await Promise.all(promises);
}
exports.dbRange = dbRange;
//# sourceMappingURL=dbRange.js.map